searchData={"items":[{"type":"module","title":"AshMock","doc":"","ref":"AshMock.html"},{"type":"macro","title":"AshMock.mock/1","doc":"","ref":"AshMock.html#mock/1"},{"type":"module","title":"AshMock.Change","doc":"","ref":"AshMock.Change.html"},{"type":"function","title":"AshMock.Change.change/3","doc":"Callback implementation for  Ash.Resource.Change.change/3 .","ref":"AshMock.Change.html#change/3"},{"type":"module","title":"AshMock.Info","doc":"","ref":"AshMock.Info.html"},{"type":"function","title":"AshMock.Info.mock/1","doc":"mock DSL entities","ref":"AshMock.Info.html#mock/1"},{"type":"function","title":"AshMock.Info.mock_enforce_random/1","doc":"Fields that will be randomized by AshRandomParams.\nSee `AshRandomParams` for more information.","ref":"AshMock.Info.html#mock_enforce_random/1"},{"type":"function","title":"AshMock.Info.mock_enforce_random!/1","doc":"Fields that will be randomized by AshRandomParams.\nSee `AshRandomParams` for more information.","ref":"AshMock.Info.html#mock_enforce_random!/1"},{"type":"function","title":"AshMock.Info.mock_exclude/1","doc":"Fields that will be excluded by AshRandomParams.\nSee `AshRandomParams` for more information.","ref":"AshMock.Info.html#mock_exclude/1"},{"type":"function","title":"AshMock.Info.mock_exclude!/1","doc":"Fields that will be excluded by AshRandomParams.\nSee `AshRandomParams` for more information.","ref":"AshMock.Info.html#mock_exclude!/1"},{"type":"function","title":"AshMock.Info.mock_options/1","doc":"mock DSL options\n\nReturns a map containing the and any configured or default values.","ref":"AshMock.Info.html#mock_options/1"},{"type":"module","title":"AshMock.PostChange","doc":"","ref":"AshMock.PostChange.html"},{"type":"module","title":"AshMock.PreChange","doc":"","ref":"AshMock.PreChange.html"},{"type":"module","title":"AshMock.Transformer","doc":"","ref":"AshMock.Transformer.html"},{"type":"function","title":"AshMock.Transformer.after?/1","doc":"Callback implementation for  Spark.Dsl.Transformer.after?/1 .","ref":"AshMock.Transformer.html#after?/1"},{"type":"function","title":"AshMock.Transformer.after_compile?/0","doc":"Callback implementation for  Spark.Dsl.Transformer.after_compile?/0 .","ref":"AshMock.Transformer.html#after_compile?/0"},{"type":"function","title":"AshMock.Transformer.before?/1","doc":"Callback implementation for  Spark.Dsl.Transformer.before?/1 .","ref":"AshMock.Transformer.html#before?/1"},{"type":"function","title":"AshMock.Transformer.transform/1","doc":"Callback implementation for  Spark.Dsl.Transformer.transform/1 .","ref":"AshMock.Transformer.html#transform/1"},{"type":"extras","title":"AshMock","doc":"# AshMock\n\nA mock resource generator extension for Ash resources.","ref":"readme.html"},{"type":"extras","title":"Installation - AshMock","doc":"Add `ash_mock` to your list of dependencies in `mix.exs`:\n\n```elixir\ndef deps do\n  [\n    {:ash_mock, \"~> 0.2.0\"}\n  ]\nend\n```","ref":"readme.html#installation"},{"type":"extras","title":"Usage - AshMock","doc":"AshMock provides a convenient way to generate mock resource for your Ash resources. Here's how to use it:\n\n```elixir\ndefmodule Post do\n  use Ash.Resource, domain: Domain, data_layer: Ash.DataLayer.Ets, extensions: [AshMock]\n\n  ets do\n    private? true\n  end\n\n  attributes do\n    uuid_primary_key :id\n\n    attribute :title, :string, allow_nil?: false, public?: true\n    attribute :tag, :string, allow_nil?: true, public?: true\n  end\n\n  actions do\n    defaults [:read, :destroy, create: :*, update: :*]\n  end\n\n  relationships do\n    belongs_to :author, Author, allow_nil?: false, public?: true\n  end\nend\n\ndefmodule Author do\n  use Ash.Resource, domain: Domain, data_layer: Ash.DataLayer.Ets, extensions: [AshMock]\n\n  ets do\n    private? true\n  end\n\n  attributes do\n    uuid_primary_key :id\n\n    attribute :name, :string, allow_nil?: false, public?: true\n  end\n\n  relationships do\n    has_many :posts, Post, public?: true\n  end\n\n  actions do\n    defaults [:read, :destroy, create: :*, update: :*]\n  end\nend\n```","ref":"readme.html#usage"},{"type":"extras","title":"Example Test - AshMock","doc":"```elixir\ntest \"mock\" do\n  post = Post |> Ash.Changeset.for_create(:mock) |> Ash.create!()\n\n  assert post.author.name |> String.starts_with?(\"name-\")\n  assert post.title |> String.starts_with?(\"title-\")\n  assert post.tag == nil\nend\n\ntest \"shallow_mock\" do\n  author = Author |> Ash.Changeset.for_create(:shallow_mock) |> Ash.create!()\n  post = Post |> Ash.Changeset.for_create(:shallow_mock, %{author: author}) |> Ash.create!()\n\n  assert author.id == post.author_id\n\n  assert author.name |> String.starts_with?(\"name-\")\n  assert post.title |> String.starts_with?(\"title-\")\n  assert post.tag == nil\nend\n```","ref":"readme.html#example-test"},{"type":"extras","title":"Features - AshMock","doc":"- Automatic mock resource generation for Ash resources\n- Deep relationship mocking\n- Customizable mock data patterns\n- Random value generation using AshRandomParams (see https://github.com/devall-org/ash_random_params for more information)","ref":"readme.html#features"},{"type":"extras","title":"License - AshMock","doc":"MIT","ref":"readme.html#license"}],"proglang":"elixir","content_type":"text/markdown","producer":{"name":"ex_doc","version":"0.38.1"}}